## ******************************************************** 
##
##  Name: lam.tcl Version 1.0
##
## Description:
## Provides Tcl procedures specific to the mpi API and LAM.
##
## Comments:
##
## ******************************************************** 
;#barecode

package provide lam 1.0
;## if some c++ code becomes necessary, it will exist
;## as the Tcl extension package named lamAPI.
;##package require lamAPI

namespace eval lam { }
;#end


## ******************************************************** 
##
## Name: lam::pushSchema
##
## Description:
## Write process and boot schema files into the lam users
## home directory to be used by lamboot to start lamd's.
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::pushSchema { user host } {
     if { [ catch {
        
        set pschema "\# LAM process schema\n"
        append pschema "\# generated by LDAS\n"
        append pschema "lamd \$inet_topo"
        
        set pschemaf conf.lam
        
        if { ! [ file exists conf.lam ] } {
           set fid [ open $pschemaf w ]
           puts $fid $pschema
           ::close $fid
        }
        
        ;## here we try to scp once, and if we get an error
        ;## we try once more, if that fails we bail out with
        ;## a fatal error.
        if { [ catch {
           eval ::exec scp -B $pschemaf ${user}@$host:
           ::exec ssh -x -n -obatchmode=yes ${user}@$host sync
        } err ] } {
           eval ::exec scp -B $pschemaf ${user}@$host:
           ::exec ssh -x -n -obatchmode=yes ${user}@$host sync
        }
     
     } err ] } {
        catch { ::close $fid }
        set err "${user}@$host: $err"
        return -code error "[ myName ]: $err"
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::nodelist
##
## Description:
## Helper for lam::pushSchema which returns a properly
## formatted list of node names to be used in creating the
## boot schema.
##
## Parameters:
##
## Usage:
##
## Comments:
## Tries to use a standard naming convention for nodes
## which allows sorting of node names and therefore more
## user-friendly report generation.
## Arbitrary node names are supported.

proc lam::nodelist { jobid args } {
     
     set tmp [ list ]
     set i 0
     if { [ llength $args ] == 1 } { 
        set args [ lindex $args 0 ] 
     }

     set nodes $args
     
     if { [ catch {
        set tmp [ lindex $::NODENAMES 0 ]
        foreach node $nodes {
           lappend tmp [ lindex $node 0 ]
        }
        debugPuts "using nodes: '$tmp'"
        set nodes [ join [ split $tmp ] "\n" ]
     } err ] } {
        return -code error "[ myName ]: $err"
     }
     return $nodes 
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::mpirunSchema
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::mpirunSchema { jobid scheme } {
     
     if { [ catch {
        
        regexp {\d+} $jobid job
        
        set usr [ set ::mpi::queue($job,usr) ]
        set bal [ set ::mpi::queue($job,bal) ]
        
        if { ! [ string length $usr ] } {
           return -code error "could not match user to job, Aborting."
        }
        
        set host $::WRAPPERHOST
        
        set mschema "\# LAM mpirun schema\n\# generated by LDAS\n$scheme"
        set mschemaf mschema.$jobid
        set mschemaf /tmp/$mschemaf
        set fid [ open $mschemaf w ]
        puts $fid $mschema
        close $fid
        
     } err ] } {
        catch { file delete -force $mschemaf }
        return -code error "[ myName ]: $err"
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::boot
##
## Description:
## Calls lamboot asynchronously, capturing all output into
## the mpi API log.
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::boot { jobid { user "" } { host "" } } {
     
     if { [ catch {
        set seqpt {}
        set lamd_crash_rx {already able to determine your remote shell}
        set node_rx {remote node \"([^\"]+)}
        
        regexp {\d+} $jobid job
        
        ;## plenty of opportunity to mess up here!!
        ;## don't redefine this unless you have read the docs
        ;## for the exact lam version in use.
        set flags "-b -v -s -H"
        if { [ info exists ::LAM_BOOT_FLAGS ] && \
             [ string length [ lindex $::LAM_BOOT_FLAGS 0 ] ] } {
           set flags $::LAM_BOOT_FLAGS
        }
        
        set bschema [ pwd ]/bootschema.lam
        
        if { ! [ string length $host ] } {
           set host $::WRAPPERHOST
        }
        if { ! [ string length $user ] } {
           set user [ set ::mpi::queue($job,usr) ]
        }
       
        lam::pushSchema $user $host
        
        set envopts [ join [ lrange $::MPIRUN_DASHX_OPTIONS 1 end ] ]
        set envopts [ subst $envopts ]
        
        set cmd    "|$::MPI_RSH_COMMAND -n -l $user $host "
        append cmd "/usr/bin/env LAMRSH=$::LAMRSH "
        append cmd "LAMHOME=$::LAMHOME $envopts "
        append cmd "$::LAMHOME/bin/lamboot $flags $bschema"
        
        if { [ info exists ::mpi::queue($user,lamstate) ] } {
           ::unset ::mpi::queue($user,lamstate)
        }
        
        set fid [ open $cmd w+ ]
        
        lam::ready $jobid $user $host $fid
        
     } err ] } {
        return -code error "[ myName ]:$seqpt $err"
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::ready
##
## Description:
## If called with a single argument that looks like a
## file handle it will close the filehandle in a catch
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::ready { jobid { user "" } { host "" } { fid "" } } {
     
     if { [ catch {
        
        if { [ regexp {^file\d+$} $jobid ] } {
           catch { ::close $jobid }
        } else {   
           ;## instead of lam::ready we try a delay
           set div $::LAMBOOT_RATE_NODES_PER_SECOND
           set delay \
              [ expr {(([ llength $::NODENAMES ] / $div) + 1) * 1000 } ]
           
           set result ok!
           
           ;## define ::RUN_RECON_AFTER_LAMBOOT and maybe learn a
           ;## great deal!
           if { $::RUN_RECON_AFTER_LAMBOOT == 1 } {
              catch { exec recon bootschema.lam } Result
              if { [ regexp -nocase -- {Woo\s*hoo!} $Result ] } {
                 set result ok!
              } else {
                 ;## recon generates a string beginning with 'ERROR:'
                 set result "lamboot errors: $Result"
              }
           }
           
           set ok [ list $jobid $user $host $result ]
        
           after $delay [ list set ::mpi::queue($user,lamstate) $ok ]

           set delay \
              [ expr { $delay * 2 } ]
           after $delay [ list lam::ready $fid ]
        }
     } err ] } {
        addLogEntry $err red
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::run
##
## Description:
## lam specific mpirun wrapper
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::run { jobid { flags "-v" } } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        set usr [ set ::mpi::queue($job,usr) ]
        set host $::WRAPPERHOST
        set retval [ eval ::exec \
           $::MPI_RSH_COMMAND -n -l $usr $host \
           /usr/bin/env LAMHOME=$::LAMHOME \
           LAMRSH=$::LAMRSH \
           $::LAMHOME/bin/mpirun $flags ]
     } err ] } {
        return -code error "[ myName ]: $err"
     }
     return $retval
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::state
##
## Description:
## Returns lam process info
##
## Parameters:
##
## Usage:
##
## Returned data looks like:
##
## NODE   INDEX  PID    KPRI  KSTATE             PROGRAM
## n0 (o) [1]    100003 1090  BR (-25, 0)        dlo_inet
## n0 (o) [2]    100002 1087  R  (-14, 2)        dli_inet
## n0 (o) [3]    100004 1085  BR (-13, 0)        echod
## n0 (o) [4]    100006 1085  BR (-15, 0)        flatd
## n0 (o) [5]    100007 1085  BR (-9, 0)         loadd
## n0 (o) [6]    100009 1085  BR (-7, 0)         filed
## n0 (o) [7]    100010 1085  BR (-37, 0)        traced
## n0 (o) [8]    100011 1085  R  (-14, 2)        iod
##
## Where the kstate codes are:
## R  - running independent of lam
## BR - blocked receiving
## BS - blocked sending
## F  - no longer a lam process (?)
##
## Comments:
##

proc lam::state { jobid user host { flags "-g N" } } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        set retval [ eval ::exec \
           $::MPI_RSH_COMMAND -n -l $user $host \
           /usr/bin/env LAMHOME=$::LAMHOME \
           LAMRSH=$::LAMRSH \
           $::LAMHOME/bin/state $flags ]
     } err ] } {
        return -code error "[ myName ]: $err"
     }
     
     return $retval
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::ssh
##
## Description:
## If SSH is set up correctly, the arguments will be
## executed on the remote machine -- all stdout and
## stderr will be captured and parsed.
##
## Usage:
##
## Comments:
## The resource file for the mpi API, LDASmpi.rsc
## almost certainly needs to be hand edited per site.
##
## Note that the command passed to ssh is enclosed in
## single quotes ''.
##

proc lam::ssh { jobid mpi_opts wrapper_opts { flags "-O -nw" } } {
     
     set host $::WRAPPERHOST
     set pubdir $::env(RUNDIR)/${::API}API
     regexp {\d+} $jobid job
     set usr [ set ::mpi::queue($job,usr) ]
     set loc $::env(HOST)
     set err [ list ]
     set rsh $::MPI_RSH_COMMAND
     set dashx $::MPIRUN_DASHX_OPTIONS
     set extra_flags [ string trim $::MPIRUN_EXTRA_FLAGS ]
     set flags [ concat $flags $extra_flags ]
     set wrapperAPI $::WRAPPER_API_CMD
     
     set cmd_base "|/usr/bin/env LD_PRELOAD="
     
     ;## new default since lam 0.7.0
     if { [ info exists ::MPI_RSH_COMMAND ] && \
          [ string equal ssh $::MPI_RSH_COMMAND ] } {
        set cmd_base "$cmd_base $rsh -x -n -obatchmode=yes ${usr}@$host"
     } else {
        set cmd_base "$cmd_base $rsh -n -l $usr $host"
     }
     set cmd_base "$cmd_base alias cd=cd && cd $pubdir"
     set cmd_base "$cmd_base &&"
     
     ;## we need to protect our compound options from ssh!
     regsub -all -- {[\}\{]} $mpi_opts {} mpi_opts
     regsub -all -- {[\}\{]} $wrapper_opts {} wrapper_opts
     regsub -all -- {:} $wrapper_opts \\\\\\: wrapper_opts
     
     set schema "$mpi_opts $dashx $wrapperAPI $wrapper_opts"
     regsub -all {__sPaCe__} $schema { } schema
     lam::mpirunSchema $jobid [ subst $schema ]
      
     set lam_cmd "$cmd_base mpirun $flags /tmp/mschema.$jobid 2>@stdout"
     
     debugPuts "$lam_cmd ( [ subst $schema ] )"
     
     set ::mpi::queue($job,cmd) $lam_cmd
     
     catch { lam::shell $jobid } cmd_pid
     
     regsub -all {\"} $cmd_pid {'} cmd_pid
     
     switch -regexp -- $cmd_pid {
        {Permission\s+denied} {
                   set err "Permission denied for $usr $loc -> $host"
                            }
        {Command\s+not\s+found} {
                             set err $cmd_pid         
                            }
           {cannot\s+start} {
                             set err $cmd_pid                  
                            }
      {no\s+lamd\s+running} {
                             set err $cmd_pid
                            }
                {^file\d+$} {
                            }
                    {^\d+$} {
                            }
                    default {
                            addLogEntry $cmd_pid red
                            }
     }
     if { [ string length $err ] } {
        return -code error "[ myName ]: $err"
     }    
     return $cmd_pid
}
## ********************************************************

## ******************************************************** 
##
## Name: lam::shell
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::shell { jobid } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        set done 0
        set err [ list ]
        
        ;## for asynchronous loss of job state - usually caused
        ;## by an internal lam error.
        if { ! [ info exists ::mpi::queue($job,cmd) ] } {
           set err    "No command registered for jobid: '$jobid'. "
           append err "Since it is impossible to get to this point "
           append err "without a command, this job must have been "
           append err "aborted asynchronously. SEE THE LOGS FOR "
           append err "THIS JOB. Bailing out now!"
           return -code error $err
        }
        
        set cmd $::mpi::queue($job,cmd)
        set fid [ open $cmd w+ ]

        fconfigure $fid -blocking off
        fconfigure $fid -buffering full
        
        set ::mpi::queue($job,shell) $fid
        
        fileevent $fid readable [ list lam::shellLog $jobid $fid ]
        lam::shellLog $jobid $fid
     
     } err ] } {
        return -code error "[ myName ]: $err"
     }
     return $fid
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::shellLog
##
## Description:
## This was formerly the one place that the mpi API
## could loop interminably, so we added bail-out code.
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::shellLog { jobid fid args } {
     
     if { [ catch {
        if { ! [ info exists ::TRUNCATE_LOG_LIMIT ] } {
           set ::TRUNCATE_LOG_LIMIT 2048
        }

        set max_iter $::LAM_SHELL_LOG_INFINITE_LOOP
        regexp {\d+} $jobid job
        fileevent $fid readable {} 
        set err [ list ]
        set i 0
        while { [ gets $fid line ] >= 0 } {
           append err "$line\n"
           after 1
           incr i
           if { $i >= $max_iter } {
              
              ;## truncate and add notice to long messages
              set len [ string length $err ]
              if { $len > $::TRUNCATE_LOG_LIMIT } {
                 set limit [ expr { $::TRUNCATE_LOG_LIMIT - 48 } ]
                 set trunc [ expr { $len - $limit } ]
                 set err [ string range $err 0 $limit ]
                 append err " (truncated $trunc bytes from message)"
              }
              
              set msg "gets on $fid iterated $i times, "
              append msg "bailing out now!"
              return -code error $msg
           }
        }
        
        ;## permit on-the-fly debugging/adjusting
        if { [ info exists ::DEBUG_LAM_SHELL_LOG ] } {
           if { [ string equal 1 $::DEBUG_LAM_SHELL_LOG ] } {
              addLogEntry "iterated $i times on $fid" blue
           }
        }
        
        set error [ string trim $err "\n" ]
        if { [ string length $err ] } {
           lam::shellLogParser $jobid $err
        }
     } err2 ] } {
        addLogEntry "$err2 '$err'" red
     }
     if { [ info exists ::mpi::queue($job,shell) ] } {
        fileevent $fid readable [ list lam::shellLog $jobid $fid ]
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::shellLogParser
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
## All known cases are handled explicitly.
##
## July 2003 - added lamboot to 'no lamd running' condition,
## assuming that wrapperAPI has not been started at this
## point so job should be salvageable.
##

proc lam::shellLogParser { jobid err } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        
        set usr UNKNOWN
        set host $::WRAPPERHOST
        set loc $::env(HOST)
        set nodes UNKNOWN
        
        if { [ info exists ::mpi::queue($job,usr) ] } {
           set usr [ set ::mpi::queue($job,usr) ]
        }
        if { [ info exists ::mpi::queue($job,nod) ] } {
           set nodes [ set ::mpi::queue($job,nod) ]
        }
        
        if { [ info exists ::mpi::queue($job,shell) ] } {
           
           switch -regexp -- $err {
                {MPI_INIT} {
                            append err " (user: '$usr' nodes: '$nodes')"
                            if { [ lam::mpiInitError $jobid $err ] } {
                               lappend ::mpi::queue($job,ero) $err
                               set ::mpi::queue($job,end) 1
                            } else {
                               set msg "$err (running lamboot now and "
                               append msg "retrying job in 5 seconds)"
                               addLogEntry $msg red
                            }
                           }
     {Permission\s+denied} {
                            set err    "Permission denied for "
                            append err "${usr}@$loc -> $host"
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
               {set_stdio} {
                            if { [ lam::mpiInitError $jobid $err ] } {
                               lappend ::mpi::queue($job,ero) $err
                               set ::mpi::queue($job,end) 1
                            } else {
                               set msg "(will retry once in "
                               append msg "5 seconds)"
                               set msg "$err $msg"
                               addLogEntry $msg orange
                            }
                           }
                 {Success} {
                            if { [ lam::mpiInitError $jobid $err ] } {
                               lappend ::mpi::queue($job,ero) $err
                               set ::mpi::queue($job,end) 1
                            } else {
                               set msg "(will retry once in "
                               append msg "5 seconds)"
                               set msg "$err $msg"
                               addLogEntry $msg orange
                            }
                           }
                 {^mpirun} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
                 {^Master} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
   {Command\s+not\s+found} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1         
                           }
  {cannot\s+open\s+shared} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
          {cannot\s+start} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1     
                           }
     {no\s+lamd\s+running} {
                            append err " (user: '$usr' nodes: '$nodes')"
                            if { [ lam::mpiInitError $jobid $err ] } {
                               lappend ::mpi::queue($job,ero) $err
                               set ::mpi::queue($job,end) 1
                            } else {
                               set msg "$err (running lamboot now and "
                               append msg "retrying job in 5 seconds)"
                               addLogEntry $msg red
                            }
                           }
       {group\s+is\s+dead} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
      {relocation\s+error} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
                     {SIG} {
                            lappend ::mpi::queue($job,ero) $err
                            set ::mpi::queue($job,end) 1
                           }
                   default {
                            addLogEntry $err blue
                           }
           }
        } else {
           set subject "$::LDAS_SYSTEM ${::API}API error!"
           set body "[ myName ]: stdout/stderr received from "
           append body "unknown jobid: '$jobid'.\n"
           append body "message received:\n'$err'"
           set msg "Subject ${subject}; Body: $body"
           addLogEntry $msg email
        }
     } err ] } {
        return -code error "[ myName ]: $err"
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::mpiInitError
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::mpiInitError { jobid err } {
     
     if { [ catch {
         regexp {\d+} $jobid job
        
        set user UNKNOWN
        set host $::WRAPPERHOST
        set loc $::env(HOST)
        set nodes UNKNOWN
        
        if { [ info exists ::mpi::queue($job,usr) ] } {
           set user [ set ::mpi::queue($job,usr) ]
        }
        if { [ info exists ::mpi::queue($job,nod) ] } {
           set nodes [ set ::mpi::queue($job,nod) ]
        }
        
        if { ! [ info exists ::mpi::queue($job,retry) ] } {
           set ::mpi::queue($job,retry) 0
        } else {
           incr ::mpi::queue($job,retry)
        }
        
        set retry $::mpi::queue($job,retry)
        
        set shell $::mpi::queue($job,shell)
        
        if { $retry == 0 } {
           ::close $shell
           ::unset ::mpi::queue($job,shell)
           
           lam::boot $jobid $user $host
           
           if { ! [ info exists ::mpi::queue($user,lamstate) ] } {
              vwait ::mpi::queue($user,lamstate)
           }
           set state $::mpi::queue($user,lamstate)
           
           if { [ regexp {ERROR!!} $state ] } {
              return -code error $state
           }
           
           addLogEntry $state blue
           
           after 2000 [ list lam::shell $jobid ]
        } else {   
           set subject "$::LDAS_SYSTEM ${::API}API error!"
           set body "LAM SYSTEM ERROR!!\n${err}\n"
           append body "(error message may be truncated)"
           append body "\n(jobid: '$jobid' "
           append body "user: '$user' nodes: '$nodes') " 
           append body "cluster state: $::mpi::queue(NULL,nod)"
           addLogEntry "Subject: ${subject}; Body: $body" email
        }
     } err ] } {
        return -code error "[ myName ]: $err"
     }
     return $retry
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::halt
##
## Description:
## lamhalt shuts down the lam daemons
##
## Parameters:
## flags - options to lamhalt(1)
##
## Usage:
##    -v verbose
##
## Comments:
## This is intended to be run in the LAM user's home
## directory on the beowulf gateway.
##

proc lam::halt { usr } {
     
     if { [ catch {
        
        set retval [ list ]
        
        if { [ regexp ${::RUNCODE}\\d+ $usr ] } {
           set jobid $usr
           regexp {\d+} $jobid job
           unset usr
           if { [ info exists ::mpi::queue($job,usr) ] } {
              set usr [ set ::mpi::queue($job,usr) ]
           }
        }
        
        if { ! [ info exists usr ] } { return }
        
        set host $::WRAPPERHOST
        
        set retval \
           [ eval ::exec \
           $::MPI_RSH_COMMAND -n -l $usr $host \
           /usr/bin/env LAMHOME=$::LAMHOME \
           LAMRSH=$::LAMRSH \
           $::LAMHOME/bin/lamhalt ]
        
        set err_rx {(try|fail|bad|documentation|error|seems)}
        ;## potentially dangerous regexp
        if { [ regexp $err_rx $retval ] } {
           return -code error $retval
        }
        
     } err ] } {
        if { [ string length $err ] } {
           addLogEntry $err red
        }
     }
     return $retval
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::clean
##
## Description:
## lamclean cleans up a lam multicomputer without doing a
## halt/ lamboot.
##
## If it is called and does not return, then it is necessary
## to do a halt/boot.
##
## Parameters:
## flags - options to lamhalt(1)
##
## Usage:
##    -v verbose
##
##  example:
##           lamclean -v
##             killing processes, done
##             closing files, done
##             sweeping traces, done
##             cleaning up registered objects, done
##             sweeping messages, done
##
## message when no multicomputer was present:
##
##  '...no lamd running...'
##
## Comments:
## Tough one... how to handle the 'not return' in a reasonable
## time?  Well, since we cycle through users it should be OK.
##

proc lam::clean { jobid user { flags "-v" } } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        set host $::WRAPPERHOST
        
        set cmd    "|$::MPI_RSH_COMMAND -n -l $user $host "
        append cmd "/usr/bin/env LAMHOME=$::LAMHOME "
        append cmd "LAMRSH=$::LAMRSH "
        append cmd "$::LAMHOME/bin/lamclean $flags 2>@stdout"
        
        set fid [ open $cmd w+ ]
        fconfigure $fid -blocking off

        set ::mpi::queue(cleanup,$job) [ list $fid $user ]
        
        after 20000 lam::cleanTimeout $jobid
        
        fileevent $fid readable \
           [ list lam::cleanHandler $jobid $user $fid ]
        
     } err ] } {
        if { [ info exists fid ] } {
           ::close $fid
        }
        if { [ info exists ::mpi::queue(cleanup,$job) ] } {
           ::unset ::mpi::queue(cleanup,$job)
        }
        if { [ string length $err ] } {
           return -code error "[ myName ]: $err"
        }
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::cleanTimeout
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::cleanTimeout { jobid args } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        if { [ info exists ::mpi::queue(cleanup,$job) ] } {
           foreach [ list fid user ] $::mpi::queue(cleanup,$job) { break }
           ::unset ::mpi::queue(cleanup,$job)
           ::close $fid
           mpi::killAllMpirun $::MGRKEY $jobid $user
        }
     } err ] } {
        set subject "$::LDAS_SYSTEM ${::API}API error!"
        set body "lamclean for user '$user' never returned and "
        append body "an error was encountered while trying to "
        append body "clean up: '$err' (jobid: $jobid)"
        addLogEntry "Subject: ${subject}; Body: $body" email
     }
}
## ******************************************************** 

## ******************************************************** 
##
## Name: lam::cleanHandler
##
## Description:
##
## Parameters:
##
## Usage:
##
## Comments:
##

proc lam::cleanHandler { jobid user fid args } {
     
     if { [ catch {
        regexp {\d+} $jobid job
        fileevent $fid readable {} 
        set error [ list ]
        while { [ gets $fid line ] >= 0 } {
           append error "$line\n"
        }
        set error [ string trim $error "\n" ]
        set error [ string trim $error ]
        if { [ string length $error ] } {
           if { [ regexp {no\s+lamd\s+running} $error ] } {
              set level red
           } elseif { [ regexp {,\s+done$} $error ] } {
              set level green
           } elseif { [ regexp {done$} $error ] } {
              set level green
           } elseif { [ regexp {Hangup$} $error ] } {
              set level green
           } else {
              set level red
           }
           addLogEntry "lamclean: ${user}: $error" $level
           if { [ string equal red $level ] } {
              catch { ::close $fid }
              catch { ::unset ::mpi::queue(cleanup,$job) }
              mpi::prestartLamds $jobid $user
           } elseif { [ string equal green $level ] } {
              catch { ::close $fid }
              catch { ::unset ::mpi::queue(cleanup,$job) }
              set ::mpi::waitforlamboot 0
           }
        }
        
        if { [ info exists ::mpi::queue(cleanup,$job) ] } {
           fileevent $fid readable \
              [ list lam::cleanHandler $jobid $user $fid ]
        }
        
     } err ] } {
        if { [ info exists fid ] } {
           ::close $fid
        }
        if { [ info exists ::mpi::queue(cleanup,$job) ] } {
           ::unset ::mpi::queue(cleanup,$job)
        }
        addLogEntry "(user: $user) $err '$error'" red
        mpi::prestartLamds $jobid $user
     }
}
## ******************************************************** 

